﻿// ----------------------------------------------------------------------------------------
// Author:                    Joaquín López y Magally Vargas
// Company:                   Albalia Interactiva S.L
// Assembly version:          1.0.0.0
// Date:                      10/02/2009
// Time:                      12:13
// Solution Name:             FacturaeAdd-in
// Solution Filename:         FacturaeAdd-in.sln
// Solution FullFilename:     C:\Ribbon_Facturae\FacturaeAdd-in.sln
// Project Name:              FacturaeAdd-in
// Project Filename:          FacturaeAdd-in.csproj
// Project FullFilename:      C:\Ribbon_Facturae\FacturaeAdd-in\FacturaeAdd-in.csproj
// Project Item Name:         Paths.cs
// Project Item Filename:     Paths.cs
// Project Item FullFilename: C:\Ribbon_Facturae\FacturaeAdd-in\Paths.cs
// Project Item Kind:         Código
// Purpose:                   Almacenar todas las rutas de los archivos utilizados en la aplicación
//Copyright © 2008 - 2009 Albalia Interactiva S.L. Reservados todos los derechos.
// ----------------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FacturaeAdd_in
{
    /// <summary>
    /// Clase estática en la que se encuentran como constantes los paths que se utilizan
    /// en toda la aplicación.
    /// </summary>
    public static class Paths
    {
        #region "Constants"


        /// <summary>
        /// Constante que indica el path donde se encuentra el archivo con los mensages
        /// </summary>
        public const string MessagesPath = @"\Microsoft Office Word Facturae Add-In\Datos de Programa\Messages\";
        /// <summary>
        /// Constante que indica el path donde se encuentra el archivo con los tipos de persona
        /// </summary>
        public const string InformationFiles = @"\Microsoft Office Word Facturae Add-In\Datos de Programa\InformationFiles\";
        /// <summary>
        /// Constante que indica el path donde se encuentra el archivo con los tipos de persona
        /// </summary>
        public const string PersonTypePath =   @"\PersonType.txt";
        /// <summary>
        /// Constante que indica el path donde se encuentra el archivo con los tipos de residencia
        /// </summary>
        public const string ResidenceTypePath =  @"\ResidenceType.txt";
        /// <summary>
        /// Constante que indica el path donde se encuentra el archivo con los tipos de vía
        /// </summary>
        public const string RoadTypePath =   @"\RoadType.txt";
        /// <summary>
        /// Constante que indica el path donde se encuentra el archivo con los poblaciones
        /// </summary>
        public const string StatesPath =   @"\States.txt";
        /// <summary>
        /// Constante que indica el path donde se encuentra el archivo con los paises
        /// </summary>
        public const string CountriesPath =   @"\Countries.txt";

        /// <summary>
        ///  Constante que indica el path donde se encuentra el archivo con los años del taskPane
        /// </summary>
        public const string YearsPath =  @"\Microsoft Office Word Facturae Add-In\Datos de Programa\InformationFiles\Years.txt";

        /// <summary>
        /// Constante que indica el path donde se encuentra el archivo con las URLs de timestamp
        /// </summary>
        public const string UrlTimeStamp =   @"\Microsoft Office Word Facturae Add-In\Datos de Programa\InformationFiles\UrlTimeStamp.txt";

        /// <summary>
        /// Constante que indica el path donde se encuentra el archivo de lenguaje de español
        /// </summary>
        /// 
        public const string LanguagesPath =   @"\Microsoft Office Word Facturae Add-In\Datos de Programa\Languages\";
        /// <summary>
        /// Constante que indica el path donde se encuentra el archivo de configuración de los datos de la empresa
        /// </summary>
        public const string ConfigPath =   @"\Microsoft Office Word Facturae Add-In\Datos de Programa\Configuration\Config.xml";
        
        /// <summary>
        /// Constante que indica el path donde se encuentra las plantillas
        /// </summary>
        public const string TemplatePath =   @"\Microsoft Office Word Facturae Add-In\Datos de Programa\Templates\";
        /// <summary>
        /// Constante que indica el path donde se encuentra el archivo con la parte extraida de la factrae.
        /// </summary>
        public const string InvoiceExtractPath =   @"\Microsoft Office Word Facturae Add-In\Datos de Programa\customXmlPart.xml";
        /// <summary>
        /// Constante que indica el path donde se encuentra el archivo con el esquema de la facturae.
        /// </summary>
        public const string SchemaPath =   @"\Microsoft Office Word Facturae Add-In\Datos de Programa\XmlSchemas\facturae2.xsd";
        /// <summary>
        /// Constante que indica el path donde se encuentran todas las facturas emitidas.
        /// </summary>
        public const string IssuedPath =   @"\Microsoft Office Word Facturae Add-In\Datos de Programa\InvoiceMng\Issued\";
        /// <summary>
        /// Constante que indica el path donde se encuentran todas las facturas recibidas.
        /// </summary>
        public const string ReceivedPath =   @"\Microsoft Office Word Facturae Add-In\Datos de Programa\InvoiceMng\Received\";
        /// <summary>
        /// Constante que indica el path donde se encuentran todas las facturas borradores.
        /// </summary>
        public const string DraftPath =   @"\Microsoft Office Word Facturae Add-In\Datos de Programa\InvoiceMng\Draft\";
        /// <summary>
        /// Constante que indica el path donde se encuentran la bitcora.
        /// </summary>
        public const string BitacoraPath =  @"\Microsoft Office Word Facturae Add-In\Datos de Programa\InvoiceMng\bitacora.xml";

        /// <summary>
        /// Constante que indica el path donde se encuentran el archivo temporal utilizado para el custompart.
        /// </summary>
        public const string CustomXmlPartPath =  @"\Microsoft Office Word Facturae Add-In\Datos de Programa\customXmlPart.xml";

        /// <summary>
        /// Constante que indica el path donde se encuentran el archivo temporal utilizado para la firma.
        /// </summary>
        public const string SignateCustomXmlPartPath =   @"\Microsoft Office Word Facturae Add-In\Datos de Programa\SignateCustomXmlPart.xml";

        /// <summary>
        /// Constante que indica el path donde se encuentran el archivo con los valores de la última búsqueda.
        /// </summary>
        public const string LastSearchParameterPath =   @"\Microsoft Office Word Facturae Add-In\Datos de Programa\Configuration\LastSearchParameter.xml";
        
        #endregion


    }
}
