﻿// ----------------------------------------------------------------------------------------
// Author:                    Joaquín López y Magaly Vargas 
// Company:                   ALBALIA INTERACTIVA S.L.
// Assembly version:          1.0.0.0
// Date:                      05/02/2009
// Time:                      18:05
// Solution Name:             FacturaeAdd-in
// Solution Filename:         FacturaeAdd-in.sln
// Solution FullFilename:     C:\Ribbon_Facturae\FacturaeAdd-in.sln
// Project Name:              FacturaeAdd-in
// Project Filename:          FacturaeAdd-in.csproj
// Project FullFilename:      C:\Ribbon_Facturae\FacturaeAdd-in\FacturaeAdd-in.csproj
// Project Item Name:         XmlFileMngRecord.cs
// Project Item Filename:     XmlFileMngRecord.cs
// Project Item FullFilename: C:\Ribbon_Facturae\FacturaeAdd-in\XmlMngFiles\XmlFileMngRecord.cs
// Project Item Kind:         Código
// Purpose:                   Representa el registro de un fichero de gestion
//Copyright © 2008 - 2009 Albalia Interactiva S.L. Reservados todos los derechos.
// ----------------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;


namespace FacturaeAdd_in.XmlMngFiles
{

    /// <summary>
    /// representa el registro de un nuevo fichero de gestion 
    /// </summary>
    public class XmlFileMngRecord
    {
        /// <summary>
        /// atributo serializable que representa el año correspondiente a un archivo de gestion xml
        /// </summary>
    [XmlAttribute]
        public string Year = "";

        /// <summary>
        /// atributo serializable que representa el mes correspondiente a un archivo de gestion xml
        /// </summary>
    [XmlAttribute]
        public string Month = "";

        /// <summary>
        /// atributo serializable que representa el estado o tipo correspondiente a un archivo de gestion xml:
        /// Issued,Received o Draft
        /// </summary>
    [XmlAttribute]
        public string Status = "";

        /// <summary>
        /// atributo serializable que representa el directorio correspondiente a un archivo de gestion xml
        /// </summary>
    [XmlAttribute]
        public string Path = "";
   

        /// <summary>
        /// crea una nueva instancia de la clase XmlMngFile
        /// </summary>
        public XmlFileMngRecord()
        {
        }
        
        /// <summary>
        /// Crea una nueva instacia de la clase XmlMngFile con los valores pasados por parámetro
        /// </summary>
        /// <param name="year">año del fichero de gestion xml</param>
        /// <param name="month">mes del fichero de gestion xml</param>
        /// <param name="status">tipo o estado de las facturas que contendra el fichero de gestión xml</param>
        /// <param name="path">directorio del archivo de gestión xml </param>
        public XmlFileMngRecord(string year, string month, string status, string path)
        {
            this.Year = year;
            this.Month = month;
            this.Status = status;
            this.Path = path;
            
        }
    }
}
