﻿// ----------------------------------------------------------------------------------------
// Author:                    Joaquín López y Magaly Vargas 
// Company:                   ALBALIA INTERACTIVA S.L.
// Assembly version:          1.0.0.0
// Date:                      05/02/2009
// Time:                      18:04
// Solution Name:             FacturaeAdd-in
// Solution Filename:         FacturaeAdd-in.sln
// Solution FullFilename:     C:\Ribbon_Facturae\FacturaeAdd-in.sln
// Project Name:              FacturaeAdd-in
// Project Filename:          FacturaeAdd-in.csproj
// Project FullFilename:      C:\Ribbon_Facturae\FacturaeAdd-in\FacturaeAdd-in.csproj
// Project Item Name:         XmlInvoiceRecord.cs
// Project Item Filename:     XmlInvoiceRecord.cs
// Project Item FullFilename: C:\Ribbon_Facturae\FacturaeAdd-in\XmlMngFiles\XmlInvoiceRecord.cs
// Project Item Kind:         Código
// Purpose:                   Representa un archivo de gestion de facturas
//Copyright © 2008 - 2009 Albalia Interactiva S.L. Reservados todos los derechos.
// ----------------------------------------------------------------------------------------



using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;


namespace FacturaeAdd_in.XmlMngFiles
{
    /// <summary>
    /// crea la representación .net del registro de un fichero de gestión xml
    /// </summary>
    public class XmlInvoiceRecord
    {

        /// <summary>
        /// variable que contendra la información de un nuevo fichero de gestión
        /// </summary>
        public Year year { get; set; }

        /// <summary>
        /// crea la representacion del objeto serialiable YearXmlMngFile, que contendrá el mes y la información
        /// básica de las facturas generadas
        /// </summary>
        public XmlInvoiceRecord()
        {
            year = new Year();
        }

        /// <summary>
        /// crea un objeto que representa un la información de un nuevo fichero de gestión a registrar
        /// </summary>
        /// <param name="year">año del cual se creará el fichero de gestion xml</param>
        public void newYear(Year year)
        {
            this.year = year;
        }

      
    }
}
