﻿// ----------------------------------------------------------------------------------------
// Author:                    Joaquín López y Magaly Vargas 
// Company:                   ALBALIA INTERACTIVA S.L.
// Assembly version:          1.0.0.0
// Date:                      05/02/2009
// Time:                      18:06
// Solution Name:             FacturaeAdd-in
// Solution Filename:         FacturaeAdd-in.sln
// Solution FullFilename:     C:\Ribbon_Facturae\FacturaeAdd-in.sln
// Project Name:              FacturaeAdd-in
// Project Filename:          FacturaeAdd-in.csproj
// Project FullFilename:      C:\Ribbon_Facturae\FacturaeAdd-in\FacturaeAdd-in.csproj
// Project Item Name:         Year.cs
// Project Item Filename:     Year.cs
// Project Item FullFilename: C:\Ribbon_Facturae\FacturaeAdd-in\XmlMngFiles\Year.cs
// Project Item Kind:         Código
// Purpose:                   Representa un año en un archivo de gestion de facturas
//Copyright © 2008 - 2009 Albalia Interactiva S.L. Reservados todos los derechos.
// ----------------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace FacturaeAdd_in.XmlMngFiles
{
    /// <summary>
    /// Clase que permite identificar las facturas en los xml por años.
    /// </summary>
    public class Year
    {
        /// <summary>
        /// año del cual se realizara el archivo de gestión
        /// </summary>
        [XmlAttribute]
       public string Id { get; set; }

        /// <summary>
        /// representa al mes del cual se realizará el archivo de gestión
        /// </summary>
        public Month month { get; set; }

        
        /// <summary>
        /// crea una representacion de un fichero año el cual contiene un mes del cual se realizará el archivo de gestion 
        /// tomando como referencia el año actual
        /// </summary>
        public Year()
        {
            this.Id = DateTime.Now.Year.ToString();
            month = new Month();
        }

        /// <summary>
        /// crea una representacion de un fichero año el cual contiene un mes del cual se realizará el archivo de gestion 
        /// con el año indicado por parámetros
        /// </summary>
        public Year(string id)
        {
            month = new Month();
            this.Id = id;
        }

        /// <summary>
        /// agrega los datos de un nuevo mes a registrar para el año correspondiente
        /// </summary>
        /// <param name="month">objeto de tipo MonthMngFile que contiene los datos de registro del archivo de gestion por mes</param>
        public void newMonth(Month month)
        {
            this.month = month;
        }


    }
}
